local isInitiator = false

local function LoadModel(model)
    while not HasModelLoaded(model) do
        RequestModel(model)
        Citizen.Wait(0)
    end
end

local function LoadTrainModels()
    LoadModel(`freight`)
    LoadModel(`freightcar`)
    LoadModel(`freightcont1`)
    LoadModel(`freightcont2`)
    LoadModel(`freightgrain`)
    LoadModel(`metrotrain`)
    LoadModel(`tankercar`)
end

RegisterCommand("train", function(source, args, raw)
    local ped = PlayerPedId()
    SetEntityCoordsNoOffset(ped, 2203.12, 1351.25, 79.17, true, false, false)
    SetEntityHeading(ped, 217.29)
    SetGameplayCamRelativeRotation(-4.14, 0.0, -141.25)

    isInitiator = true
    TriggerServerEvent("Reproduction:Start")
end, false)

RegisterNetEvent("Reproduction:Start", function()
    if isInitiator then return end
    
    local ped = PlayerPedId()
    SetEntityCoordsNoOffset(ped, 2421.09, 1089.24, 79.39, true, false, false)
    SetEntityHeading(ped, 36.09)
    SetGameplayCamRelativeRotation(-4.03, 0.0, 36.01)

    LoadTrainModels()
    local engine = CreateMissionTrain(15, 2418.14, 1099.19, 79.66, true)

    while DoesEntityExist(engine) do -- Wait until front carriage has gone from our game
        Citizen.Wait(0)
    end

    SetEntityCoords(ped, 2025.18, 1665.01, 73.92)
    SetEntityHeading(ped, 205.62)
    SetGameplayCamRelativeRotation(-3.19, 0.0, -155.81)

    Citizen.Wait(5000)
    TriggerServerEvent("Reproduction:Move")
end)

RegisterNetEvent("Reproduction:Move", function()
    if not isInitiator then return end

    local ped = PlayerPedId()
    SetEntityCoordsNoOffset(ped, 1921.83, 2050.15, 64.44, true, false, false)
    SetEntityHeading(ped, 191.41)
    SetGameplayCamRelativeRotation(-4.45, 0.0, -170.5)
end)

Citizen.CreateThread(function()
    while true do
        InvalidateIdleCam()
        Citizen.Wait(10000)
    end
end)